/* blobfuncs.ec - Functions for LOC_USER reading/writing of blobs.
*/
/*
   RCS Header:
   -----------
   $Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/blobfuncs.ec,v 2.8 2009/02/11 18:30:34 art Exp $

   RCS Log:
   --------
   $Log: blobfuncs.ec,v $
   Revision 2.8  2009/02/11 18:30:34  art
   Fixed problem with LVARCHARS on AIX-64bit.

   Revision 2.7  2009/01/01 17:58:25  art
   Removed RCSWhat ident string which was BB specific.

   Revision 2.6  2004/08/04 17:59:13  kagel
   Removed unused var.

   Revision 2.5  2001/10/24 18:01:34  kagel
   Protected the #define of _H_LOCALEDEF from multiple definition.  This is
   needed for some versions of AIX but apparently later versions of the
   Informix SDK already define it.

   Revision 2.4  1999/10/12 16:34:08  kagel
   No change, recovery.

   Revision 2.3  1999/10/12 16:34:08  kagel
   Changed #if defined(__AIX__) to #if defined( _AIX ).

   Revision 2.2  1999/10/04 16:00:31  kagel
   Fixed a few platform specific compilation problems affecting mainly
   AIX.  Check the #if defined( __AIX__ ) for correctness if this is your
   platform.

   Revision 2.1  1999/09/01 19:14:30  kagel
   Establishing current  source version id for initial working version of
   newly modularized source.  This is Feature Version 6.1 Source revision
   2.1.

   Revision 1.1  1999/09/01 19:14:30  kagel
   Initial revision


*/

static const char RCSHeader[] = "@(#)$Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/blobfuncs.ec,v 2.8 2009/02/11 18:30:34 art Exp $";
static const char RCSCompile[] = "@(#)$cc: " __FILE__ " " __DATE__ " " __TIME__ " $";

#if defined( _AIX )  /* Needed as AIX defines a locale control structure loc_t */
#if !defined( _H_LOCALEDEF )
#define _H_LOCALEDEF
#endif
#endif

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

EXEC SQL INCLUDE sqlhdr;
EXEC SQL INCLUDE sqlca;
EXEC SQL INCLUDE sqltypes;
EXEC SQL INCLUDE datetime;
EXEC SQL INCLUDE locator;

EXEC SQL INCLUDE myschema.eh;

EXEC SQL INCLUDE prototypes.h;

 
static off_t pos = 0;
static int inblob = 0;
 
int openit( loc_t *loc, int flags, int bsize )
{
    if (inblob == 1) {
        fprintf( stderr, "Open called for new blob without close.\n"
		 "length = %d.!\n",
		 loc->loc_xfercount );
    }
    loc->loc_status = 0;
    loc->loc_xfercount = 0L;
    inblob = 0;
    blobbuff->global_length = 0 ;
    pos = 0;
    /* Make sure blob buffer is large enough to hold BLOB. */
    if (bsize > blobbuff->bbsize) {
        blobbuff->bbsize = bsize + (1024 - (bsize % 1024));
	blobbuff->buff = (char *)realloc( blobbuff->buff, blobbuff->bbsize );
    }
    memset( blobbuff->buff, 0, blobbuff->bbsize );
 
    return 0;
}
 
int writeit( loc_t *loc, char *buf, int nbytes )
{
    if ((pos + nbytes) > blobbuff->bbsize) {
        blobbuff->bbsize += (2 * (nbytes < 1024 ? 1024 : nbytes));
        blobbuff->buff = (char *)realloc( blobbuff->buff, blobbuff->bbsize );
    }
    if (!inblob)
        inblob = 1;
    memcpy( &(blobbuff->buff[pos]), buf, nbytes );
    pos += nbytes;
 
    loc->loc_xfercount += nbytes;
    blobbuff->global_length += nbytes;
 
    return 0;
}
 
int closeit( loc_t *loc )
{
    inblob = 0;
    loc->loc_status = 0;
    if (loc->loc_oflags & LOC_WONLY) {
        /* Fetching, cleanup. */
        loc->loc_indicator = 0;
        loc->loc_size = loc->loc_xfercount;
    }
    if( blobbuff->global_length != loc->loc_xfercount)
        fprintf( stderr,
		 "GLOBAL_LENGTH !=  loc->loc_xfercount <%d, %d> \n",
		 blobbuff->global_length,
		 loc->loc_xfercount );
    pos = 0;
 
    return 0;
}


