/* print_directives.ec - Support for external directives.
 */
/*
  RCS Header:
  -----------
  $Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/print_directives.ec,v 1.2 2010/11/15 00:34:45 art Exp $

  RCS Log:
  --------
  $Log: print_directives.ec,v $
  Revision 1.2  2010/11/15 00:34:45  art
  Completed support for external directives.

  Revision 1.1  2010/11/15 00:05:33  art
  Initial revision


*/

static const char RCSHeader[] = "@(#)$Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/print_directives.ec,v 1.2 2010/11/15 00:34:45 art Exp $";
static const char RCSCompile[] = "@(#)$cc: " __FILE__ " " __DATE__ " " __TIME__ " $";

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

EXEC SQL INCLUDE sqlhdr;
EXEC SQL INCLUDE sqlca;
EXEC SQL INCLUDE sqltypes;
EXEC SQL INCLUDE datetime;
EXEC SQL INCLUDE locator;

EXEC SQL INCLUDE myschema.eh;

void print_directives( FILE *outfile, FILE *outfile2 )
{
    EXEC SQL BEGIN DECLARE SECTION;
    int id;
    loc_t l_query;
    loc_t l_directive;
    int active;
    char sd_sql[1025];
    char query[65535];
    char directive[65535];
    EXEC SQL END DECLARE SECTION;
    int ndirectives = 0;

    snprintf( sd_sql,
	      sizeof sd_sql,
	      "%s;",
	      "SELECT id, query, directive, active "
	      "FROM sysdirectives "
	      "ORDER BY id " );
    EXEC SQL PREPARE sd_s FROM :sd_sql;
    if (sqlca.sqlcode < 0) {
	fprintf( stderr,
		 "Error PREPARING directive cursor.  SQL: %d  ISAM: %d.\n",
		 sqlca.sqlcode,
		 sqlca.sqlerrd[1] );
	exit(1);
    }

    /* Prepare the locator structures for BLOB processing. */
    l_query.loc_loctype = LOCMEMORY;
    l_query.loc_bufsize = sizeof query;
    l_query.loc_buffer = query;

    l_directive.loc_loctype = LOCMEMORY;    
    l_directive.loc_bufsize = sizeof directive;
    l_directive.loc_buffer = directive;

    EXEC SQL DECLARE sd_c CURSOR FOR sd_s;

    if (sqlca.sqlcode < 0) {
	fprintf( stderr,
		 "Error DECLARING directive cursor.  SQL: %d  ISAM: %d.\n",
		 sqlca.sqlcode,
		 sqlca.sqlerrd[1] );
	exit(1);
    }
    
    EXEC SQL OPEN sd_c;
    if (sqlca.sqlcode < 0) {
	fprintf( stderr,
		 "Error OPENING directive cursor.  SQL: %d  ISAM: %d.\n",
		 sqlca.sqlcode,
		 sqlca.sqlerrd[1] );
	exit(1);
    }

    for(;;) {
	memset( query, 0, sizeof query );
	memset( directive, 0, sizeof directive );

	l_query.loc_loctype = LOCMEMORY;
	l_query.loc_bufsize = sizeof query;
	l_query.loc_buffer = query;
	
	l_directive.loc_loctype = LOCMEMORY;    
	l_directive.loc_bufsize = sizeof directive;
	l_directive.loc_buffer = directive;
	EXEC SQL FETCH sd_c
	    INTO :id,
	    :l_query,
	    :l_directive,
	    :active;
	if (sqlca.sqlcode < 0) {
	    fprintf( stderr,
		     "Error DECLARING directive cursor.  SQL: %d  ISAM: %d.\n",
		     sqlca.sqlcode,
		     sqlca.sqlerrd[1] );
	    exit(1);
	} else if (sqlca.sqlcode > 0)
	    break;
	if (ndirectives++ == 0)
	    fprintf( outfile2, "\n" );
	fprintf( outfile2,
		 "SAVE EXTERNAL DIRECTIVES /*+ %s */ %s FOR\n%s;\n",
		 directive,
		 active == 1 ? "ACTIVE" : (active == 2 ? "TEST ONLY" : "INACTIVE"),
		 query );
    }
    EXEC SQL CLOSE sd_c;
    EXEC SQL FREE sd_c;
}
