/* print_violation.ec - print out start violations statement for a table if any.
*/
/*
   RCS Header:
   -----------
   $Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/print_violations.ec,v 2.8 2009/11/23 18:47:05 art Exp $

   RCS Log:
   --------
   $Log: print_violations.ec,v $
   Revision 2.8  2009/11/23 18:47:05  art
   Added support for EXTERNAL tables (11.50xc6+).
   Improved 64bit compiler support.  Removed warnings.

   Revision 2.7  2009/02/11 18:30:34  art
   Fixed problem with LVARCHARS on AIX-64bit.

   Revision 2.6  2009/01/01 17:58:25  art
   Removed RCSWhat ident string which was BB specific.

   Revision 2.5  2004/09/14 18:00:44  kagel
   Fix for mode ANSI databases.

   Revision 2.4  2004/09/14 17:12:59  kagel
   Fixing ANSI database access.

   Revision 2.3  1999/11/03 20:27:41  kagel
   No change??

   Revision 2.2  1999/11/03 20:27:41  kagel
   Had to make identifier and username length changes to support IDS.2000
   again.  Some strange interaction between my makefile and using emacs to
   check-out of RCS lost those changes.

   Revision 2.1  1999/09/29 16:44:05  kagel
   Establishing current  source version id for initial working version of
   newly modularized source.  This is Feature Version 6.1 Source revision
   2.1.

   Revision 1.2  1999/09/22 21:09:03  kagel
   Moved statement preparation and cursor declaration in here.

   Revision 1.1  1999/09/01 19:45:15  kagel
   Initial revision


*/

static const char RCSHeader[] = "@(#)$Header: /home/art/GoogleDrive/Latest\040Art's\040Stuff/myschema.d/fork/RCS/print_violations.ec,v 2.8 2009/11/23 18:47:05 art Exp $";
static const char RCSCompile[] = "@(#)$cc: " __FILE__ " " __DATE__ " " __TIME__ " $";

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

EXEC SQL INCLUDE sqlhdr;
EXEC SQL INCLUDE sqlca;
EXEC SQL INCLUDE sqltypes;
EXEC SQL INCLUDE datetime;

EXEC SQL INCLUDE myschema.eh;

EXEC SQL INCLUDE prototypes.h;

static int prepped = 0;

void print_violations( FILE *outfile )
{
    EXEC SQL BEGIN DECLARE SECTION;
    string vioname[129], dianame[129];
    int maxrows;
    EXEC SQL END DECLARE SECTION;
    char mxrws[10];

    if (conn5)
	return;

    /* Set up for START VIOLATIONS statements. */
    if (!prepped) {
	EXEC SQL PREPARE s_viols FROM
	    "SELECT v.tabname, d.tabname, maxrows \
             FROM \"informix\".sysviolations, \
                  \"informix\".systables v, \
                  \"informix\".systables d \
             WHERE targettid = ? \
               AND viotid = v.tabid \
               AND diatid = d.tabid ";
	if (sqlca.sqlcode) {
	    fprintf( stderr,
		     "Cannot PREPARE select statement for violations, error: %d.\n",
		     sqlca.sqlcode );
	    fprintf( stderr, "Error at character %d.\nStatement is:\n",
		     sqlca.sqlerrd[4] );
	    rexit(19);
	}
	prepped = 1;
    }
    EXEC SQL EXECUTE s_viols
	INTO :vioname, :dianame, :maxrows
	USING :prev.tabid;
    if (sqlca.sqlcode < 0) {
	fprintf( stderr,
		 "Error EXECUTING statement s_viols, Error = %d, ISAM = %d\n",
		 sqlca.sqlcode,
		 sqlca.sqlerrd[1] );
	rexit(14);
    } else if (!sqlca.sqlcode) {
	sprintf( mxrws, "%d", maxrows );
	fprintf( outfile,
		 "START VIOLATIONS FOR %s USING %s, %s%s%s;\n\n",
		 prev.tabname,
		 vioname,
		 dianame,
		 ((maxrows == -1) ? "" : " MAX ROWS "),
		 ((maxrows == -1) ? "" : mxrws ) );
    }
}

